## clblast 1.5.1

=== debian/changelog ===
clblast (1.5.1-2) unstable; urgency=medium

  * Move git repository to Salsa.
  * Add watch file.

 -- Gard Spreemann <gspr@nonempty.org>  Sun, 10 Jan 2021 12:33:04 +0100

clblast (1.5.1-1) unstable; urgency=medium

  * Initial release (Closes: #977907)

 -- Gard Spreemann <gspr@nonempty.org>  Tue, 22 Dec 2020 18:38:01 +0100
