## clblast 1.5.2

=== debian/changelog ===
clblast (1.5.2-2) unstable; urgency=medium

  * Add patch to correct typo in installation path of CMake
    files. (Closes: #987881)

 -- Gard Spreemann <gspr@nonempty.org>  Sat, 01 May 2021 13:55:46 +0200

clblast (1.5.2-1) unstable; urgency=medium

  * New upstream release.
  * Drop erroneous suggests caused by typo.

 -- Gard Spreemann <gspr@nonempty.org>  Wed, 20 Jan 2021 15:44:39 +0100
