=== debian/control ===
--- 
+++ 
@@ -64,7 +64,6 @@
 Depends: ${misc:Depends},
          libclblast1 (= ${binary:Version}),
          ocl-icd-opencl-dev | opencl-dev
-Suggests: liblbfgsb-doc, liblbfgsb-examples
 Description: Tuned OpenCL BLAS library (development files)
  CLBlast is a modern, lightweight, performant and tunable OpenCL BLAS
  library written in C++11. It is designed to leverage the full
