## clblast 1.5.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,7 +22,7 @@
 project("clblast" C CXX)
 set(clblast_VERSION_MAJOR 1)
 set(clblast_VERSION_MINOR 5)
-set(clblast_VERSION_PATCH 2)
+set(clblast_VERSION_PATCH 3)
 set(clblast_VERSION "${clblast_VERSION_MAJOR}.${clblast_VERSION_MINOR}.${clblast_VERSION_PATCH}")
 set(clblast_SOVERSION ${clblast_VERSION_MAJOR})
