=== debian/changelog ===
clblast (1.5.3-2) unstable; urgency=medium

  * Restrict autopkgtests to a limited set of architectures (precision
    problems on others).
  * Discover autopkgtests at run-time.

 -- Gard Spreemann <gspr@nonempty.org>  Thu, 13 Oct 2022 16:47:47 +0200

clblast (1.5.3-1) unstable; urgency=medium

  * New upstream release.
  * Drop upstreamed patch.
  * Standards-version 4.6.1.1. No changes needed.
  * Add autopkgtests.

 -- Gard Spreemann <gspr@nonempty.org>  Wed, 12 Oct 2022 20:07:27 +0200
