=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Maintainer: Gard Spreemann <gspr@nonempty.org>
 Section: math
 Priority: optional
-Standards-Version: 4.5.1
+Standards-Version: 4.6.1.1
 Build-Depends: cmake,
                debhelper-compat (= 13),
                libblas-dev,
