## clblast 1.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,10 +21,13 @@
 # CMake project details
 project("clblast" C CXX)
 set(clblast_VERSION_MAJOR 1)
-set(clblast_VERSION_MINOR 5)
-set(clblast_VERSION_PATCH 3)
+set(clblast_VERSION_MINOR 6)
+set(clblast_VERSION_PATCH 0)
 set(clblast_VERSION "${clblast_VERSION_MAJOR}.${clblast_VERSION_MINOR}.${clblast_VERSION_PATCH}")
 set(clblast_SOVERSION ${clblast_VERSION_MAJOR})
+
+# Policies
+cmake_policy(SET CMP0074 NEW)  # to make -DCBLAS_ROOT= work with newer CMake versions as well
 
 # Options and their default values
 option(BUILD_SHARED_LIBS "Build a shared (ON) or static library (OFF)" ON)
@@ -124,7 +127,7 @@
     set(FLAGS "${FLAGS} -O2")
   endif()
   if(CMAKE_CXX_COMPILER_ID STREQUAL GNU)
-    set(FLAGS "${FLAGS} -Wall -Wno-comment -Wno-return-type -Wno-switch -Wno-missing-noreturn")
+    set(FLAGS "${FLAGS} -Wall -Wno-comment -Wno-return-type -Wno-switch -Wno-missing-noreturn -Wno-unused-function")
     if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.9.0)
       set(FLAGS "${FLAGS} -Wno-attributes -Wno-unused-variable")
     endif()
@@ -138,7 +141,7 @@
     set(FLAGS "${FLAGS} -Wextra -Wno-c++98-compat -Wno-c++98-compat-pedantic -Wno-padded")
     set(FLAGS "${FLAGS} -Wno-missing-prototypes -Wno-float-equal -Wno-switch-enum -Wno-switch")
     set(FLAGS "${FLAGS} -Wno-exit-time-destructors -Wno-global-constructors -Wno-missing-noreturn")
-    set(FLAGS "${FLAGS} -Wno-deprecated-declarations")
+    set(FLAGS "${FLAGS} -Wno-deprecated-declarations -Wno-unused-function")
     if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 3.9.0)  # clang 4.0 or higher
         if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7.0.0)  # but not for AppleClang
           set(FLAGS "${FLAGS} -Wno-undefined-var-template")
@@ -304,7 +307,3 @@
   set(HEADERS ${HEADERS} src/routines/level3/${ROUTINE}.hpp)
 endforeach()
 foreach(ROUTINE ${LEVELX_ROUTINES})
-  set(SOURCES ${SOURCES} src/routines/levelx/${ROUTINE}.cpp)
-  set(HEADERS ${HEADERS} src/routines/levelx/${ROUTINE}.hpp)
-endforeach()
-foreach(DATABASE ${DATABASES})
