=== debian/changelog ===
clblast (1.6.0-1) unstable; urgency=medium

  * New upstream release.

 -- Gard Spreemann <gspr@nonempty.org>  Thu, 08 Jun 2023 11:54:29 +0200

clblast (1.5.3-3) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields.

  [ Gard Spreemann ]
  * Standards-version 4.6.2.0. No changes needed.

 -- Gard Spreemann <gspr@nonempty.org>  Thu, 26 Jan 2023 16:45:33 +0100
