## clblast 1.6.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,7 +22,7 @@
 project("clblast" C CXX)
 set(clblast_VERSION_MAJOR 1)
 set(clblast_VERSION_MINOR 6)
-set(clblast_VERSION_PATCH 0)
+set(clblast_VERSION_PATCH 1)
 set(clblast_VERSION "${clblast_VERSION_MAJOR}.${clblast_VERSION_MINOR}.${clblast_VERSION_PATCH}")
 set(clblast_SOVERSION ${clblast_VERSION_MAJOR})
