=== debian/changelog ===
clblast (1.6.1-1) unstable; urgency=medium

  * New upstream release.

 -- Gard Spreemann <gspr@nonempty.org>  Wed, 12 Jul 2023 11:51:54 +0200
