=== debian/changelog ===
clblast (1.6.2-1) unstable; urgency=medium

  * New upstream release.
  * Add patch to remain compatible with -Werror=format-security.

 -- Gard Spreemann <gspr@nonempty.org>  Sat, 10 Feb 2024 14:12:38 +0100
