=== debian/changelog ===
clblast (1.6.3-2) unstable; urgency=medium

  * Add patch to support CMake 4. (Closes: #1112786)
  * Standards-version 4.7.2.0. No changes needed.

 -- Gard Spreemann <gspr@nonempty.org>  Thu, 09 Oct 2025 11:08:43 +0200

clblast (1.6.3-1) unstable; urgency=medium

  * New upstream version.
  * Drop upstreamed patch.
  * Standards-version 4.7.0. No changes needed.

 -- Gard Spreemann <gspr@nonempty.org>  Fri, 14 Jun 2024 07:57:08 +0200
