=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

FLAGS:=-DCUBLAS=false -DCUDA=false -DNETLIB=false -DOPENCL=true

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure --builddirectory=build-static -- -DBUILD_SHARED_LIBS=false -DTUNERS=false -DTESTS=false $(FLAGS)
	dh_auto_configure --builddirectory=build --        -DBUILD_SHARED_LIBS=true  -DTUNERS=true  -DTESTS=true  $(FLAGS)

override_dh_auto_build:
	dh_auto_build --builddirectory=build-static
	dh_auto_build --builddirectory=build

override_dh_auto_clean:
	dh_auto_clean --builddirectory=build-static
	dh_auto_clean --builddirectory=build

override_dh_auto_install:
	dh_auto_install --builddirectory=build-static
	dh_auto_install --builddirectory=build

override_dh_missing:
	dh_missing --list-missing
