=== debian/tests/control ===
Tests: tests-pocl.sh
Depends: clblast-tests, colorized-logs, gcc, ocl-icd-opencl-dev | opencl-dev, pocl-opencl-icd
Architecture: amd64 arm64 i386
Restrictions: allow-stderr
