=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%clblast-$1.tar.gz%" \
     https://github.com/CNugteren/CLBlast/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
